/**
 *
 * Magnolia Criteria API (http://www.openmindlab.com/lab/products/mgnlcriteria.html)
 * Copyright (C)2009 - 2010, Openmind S.r.l. http://www.openmindonline.it
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package net.sourceforge.openutils.mgnlcriteria.jcr.query.xpath.impl;

import info.magnolia.cms.core.Content;
import info.magnolia.cms.core.HierarchyManager;
import info.magnolia.cms.core.ItemType;
import info.magnolia.cms.core.search.QueryManager;
import net.sourceforge.openutils.mgnlcriteria.jcr.query.JCRQueryException;

import org.apache.commons.lang.StringUtils;


/**
 * @author fgrilli
 * @version $Id: AbstractMagnoliaCriteriaImpl.java 2923 2010-08-29 08:58:29Z fgiust $
 */
@Deprecated
public abstract class AbstractMagnoliaCriteriaImpl extends AbstractCriteriaImpl
{

    @Deprecated
    protected info.magnolia.cms.core.search.QueryManager queryManager;

    @Deprecated
    protected String itemType;

    /**
     * @param hm
     */
    public AbstractMagnoliaCriteriaImpl(HierarchyManager hm)
    {
        super(hm);
    }

    /**
     * Constructor to be used by subclasses
     * @param path String - the path preceding the predicate in the jcr query statement (you dont need to do escaping
     * yourself)
     * @param queryManager - an instance of {@link QueryManager}
     * @param itemType - String the itemType. Defaults to {@link ItemType#getSystemName#toString()}
     * @param classType Class<?> - defaults to {@link Content}
     */
    protected AbstractMagnoliaCriteriaImpl(String path, QueryManager queryManager, String itemType, Class< ? > classType)
    {

        super(getPrivateHierarchyManagerFromQuery(queryManager));
        if (StringUtils.isBlank(itemType))
        {
            this.itemType = ItemType.CONTENT.getSystemName();
        }
        else
        {
            this.itemType = itemType;
        }
        this.path = path;
        this.queryManager = queryManager;
        // defaults to info.magnolia.cms.core.Content
        this.classType = classType == null ? Content.class : classType;
    }

    protected static HierarchyManager getPrivateHierarchyManagerFromQuery(QueryManager queryManager)
    {
        if (queryManager == null)
        {
            return null;
        }

        java.lang.reflect.Field field;
        try
        {
            field = queryManager.getClass().getDeclaredField("hm");
            field.setAccessible(true);
            HierarchyManager hm = (HierarchyManager) field.get(queryManager);
            return hm;
        }
        catch (Throwable e)
        {
            throw new JCRQueryException("getting hierarchyManager", e);
        }

    }

}